"use strict";
var _WysiwygContentHandler_view, _WysiwygContentHandler_parser;
Object.defineProperty(exports, "__esModule", { value: true });
exports.WysiwygContentHandler = void 0;
const tslib_1 = require("tslib");
const prosemirror_model_1 = require("prosemirror-model");
const prosemirror_state_1 = require("prosemirror-state");
class WysiwygContentHandler {
    constructor(view, parser) {
        _WysiwygContentHandler_view.set(this, void 0);
        _WysiwygContentHandler_parser.set(this, void 0);
        tslib_1.__classPrivateFieldSet(this, _WysiwygContentHandler_view, view, "f");
        tslib_1.__classPrivateFieldSet(this, _WysiwygContentHandler_parser, parser, "f");
    }
    clear() {
        tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.tr
            .setSelection(new prosemirror_state_1.AllSelection(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.doc))
            .replaceSelection(prosemirror_model_1.Slice.empty));
    }
    replace(newMarkup) {
        tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.tr
            .setSelection(new prosemirror_state_1.AllSelection(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.doc))
            .replaceSelection(new prosemirror_model_1.Slice(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_parser, "f").parse(newMarkup).content, 0, 0)));
    }
    prepend(markup) {
        tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.tr.insert(0, tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_parser, "f").parse(markup).content));
    }
    append(markup) {
        tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(this.appendContentTr(tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.tr, markup));
    }
    moveCursor(position) {
        switch (position) {
            case 'start': {
                const { tr } = tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state;
                tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tr.setSelection(prosemirror_state_1.TextSelection.create(tr.doc, 1)));
                break;
            }
            case 'end': {
                const { lastChild } = tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state.doc;
                const { tr } = tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").state;
                const pos = tr.doc.nodeSize - 2;
                if (!(lastChild === null || lastChild === void 0 ? void 0 : lastChild.isTextblock) && !(lastChild === null || lastChild === void 0 ? void 0 : lastChild.isText)) {
                    this.appendContentTr(tr, '');
                }
                tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_view, "f").dispatch(tr
                    .setSelection(prosemirror_state_1.TextSelection.create(tr.doc, tr.mapping.map(pos) - 1))
                    .scrollIntoView());
                break;
            }
            default:
                throw new Error('The "position" argument must be "start" or "end"');
        }
    }
    appendContentTr(tr, markup) {
        return tr.insert(tr.doc.nodeSize - 2, tslib_1.__classPrivateFieldGet(this, _WysiwygContentHandler_parser, "f").parse(markup).content);
    }
}
exports.WysiwygContentHandler = WysiwygContentHandler;
_WysiwygContentHandler_view = new WeakMap(), _WysiwygContentHandler_parser = new WeakMap();
