import type MarkdownIt from 'markdown-it';
import type { Plugin } from 'prosemirror-state';
import { ActionsManager } from './ActionsManager';
import type { ActionSpec } from './types/actions';
import type { ExtensionDeps, ExtensionSpec } from './types/extension';
import type { MarkViewConstructor, NodeViewConstructor } from './types/node-views';
declare type ExtensionsManagerParams = {
    /** Preconfigured MarkdownIt-instance */
    md: MarkdownIt;
    extensions: ExtensionSpec[];
};
export declare class ExtensionsManager {
    #private;
    static process(md: MarkdownIt, extensions: ExtensionSpec[]): {
        actions: ActionsManager;
        rawActions: Record<string, ActionSpec>;
        plugins: Plugin<any>[];
        nodeViews: Record<string, NodeViewConstructor>;
        markViews: Record<string, MarkViewConstructor>;
        schema: import("prosemirror-model").Schema<any, any>;
        parser: import(".").Parser;
        serializer: import(".").Serializer;
    };
    constructor({ md, extensions }: ExtensionsManagerParams);
    build(): {
        actions: ActionsManager;
        rawActions: Record<string, ActionSpec>;
        plugins: Plugin<any>[];
        nodeViews: Record<string, NodeViewConstructor>;
        markViews: Record<string, MarkViewConstructor>;
        schema: import("prosemirror-model").Schema<any, any>;
        parser: import(".").Parser;
        serializer: import(".").Serializer;
    };
    buildDeps(): ExtensionDeps;
    private processExtensions;
    private processNode;
    private processMark;
    private createDeps;
    private createDerived;
}
export {};
