"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseKeymap = void 0;
const prosemirror_inputrules_1 = require("prosemirror-inputrules");
const prosemirror_commands_1 = require("prosemirror-commands");
/**
 * Add this extension after all other extensions with keymaps
 */
const BaseKeymap = (builder) => {
    builder
        .addKeymap(() => ({
        Backspace: prosemirror_inputrules_1.undoInputRule,
        'Alt-ArrowUp': prosemirror_commands_1.joinUp,
        'Alt-ArrowDown': prosemirror_commands_1.joinDown,
        'Mod-BracketLeft': prosemirror_commands_1.lift,
        'Alt-Shift-Escape': prosemirror_commands_1.selectParentNode,
    }), builder.PluginPriority.Lowest)
        .addKeymap(() => prosemirror_commands_1.baseKeymap, builder.PluginPriority.Lowest);
};
exports.BaseKeymap = BaseKeymap;
