import type { NodeSpec } from 'prosemirror-model';
import type { Command } from 'prosemirror-state';
import { Action, ExtensionAuto } from '../../../core';
export declare enum BaseNode {
    Doc = "doc",
    Text = "text",
    Paragraph = "paragraph"
}
export declare const pType: (schema: import("prosemirror-model").Schema<any, any>) => import("prosemirror-model").NodeType;
declare const pAction = "toParagraph";
export declare const toParagraph: Command;
export declare type BaseSchemaOptions = {
    paragraphKey?: string | null;
    paragraphPlaceholder?: NonNullable<NodeSpec['placeholder']>['content'];
};
export declare const BaseSchema: ExtensionAuto<BaseSchemaOptions>;
/**
 * @deprecated
 * For tests only.
 * Remove after WIKI-16660
 */
export declare const BaseSchemaE: (opts?: BaseSchemaOptions | undefined) => import("../../../core").ExtensionSpec;
declare global {
    namespace YfmEditor {
        interface Actions {
            [pAction]: Action;
        }
    }
}
export {};
