"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isImageFile = exports.isFilesFromHtml = exports.isFilesOnly = exports.isIosSafariShare = exports.DataTransferType = void 0;
/** Сontains all data formats known to us */
var DataTransferType;
(function (DataTransferType) {
    DataTransferType["Text"] = "text/plain";
    DataTransferType["Html"] = "text/html";
    DataTransferType["UriList"] = "text/uri-list";
    DataTransferType["Files"] = "Files";
})(DataTransferType = exports.DataTransferType || (exports.DataTransferType = {}));
function isIosSafariShare({ types }) {
    // if link is copied from ios safari share button,
    // then data transfer only have text/uri-list data type
    return (types.includes(DataTransferType.UriList) &&
        !types.includes(DataTransferType.Text) &&
        !types.includes(DataTransferType.Html));
}
exports.isIosSafariShare = isIosSafariShare;
function isFilesOnly({ types }) {
    return types.length === 1 && types[0] === DataTransferType.Files;
}
exports.isFilesOnly = isFilesOnly;
function isFilesFromHtml({ types }) {
    return (types.length === 2 &&
        types.includes(DataTransferType.Files) &&
        types.includes(DataTransferType.Html));
}
exports.isFilesFromHtml = isFilesFromHtml;
function isImageFile(file) {
    return file.type.startsWith('image/');
}
exports.isImageFile = isImageFile;
