"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GapCursorSelection = void 0;
const prosemirror_state_1 = require("prosemirror-state");
// @ts-expect-error // TODO: implements toJSON
class GapCursorSelection extends prosemirror_state_1.Selection {
    constructor(pos) {
        super(pos, pos);
    }
    eq(other) {
        return other instanceof GapCursorSelection && other.head === this.head;
    }
    map(doc, mapping) {
        const $pos = doc.resolve(mapping.map(this.head));
        return prosemirror_state_1.Selection.near($pos);
    }
}
exports.GapCursorSelection = GapCursorSelection;
