"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.History = void 0;
const prosemirror_history_1 = require("prosemirror-history");
var HistoryAction;
(function (HistoryAction) {
    HistoryAction["Undo"] = "undo";
    HistoryAction["Redo"] = "redo";
})(HistoryAction || (HistoryAction = {}));
const History = (builder, opts) => {
    builder.addPlugin(() => (0, prosemirror_history_1.history)(opts === null || opts === void 0 ? void 0 : opts.config));
    builder.addKeymap(() => {
        const { undoKey, redoKey } = opts !== null && opts !== void 0 ? opts : {};
        const bindings = {};
        if (undoKey)
            bindings[undoKey] = prosemirror_history_1.undo;
        if (redoKey)
            bindings[redoKey] = prosemirror_history_1.redo;
        return bindings;
    });
    builder
        .addAction(HistoryAction.Undo, createHistoryAction(prosemirror_history_1.undo))
        .addAction(HistoryAction.Redo, createHistoryAction(prosemirror_history_1.redo));
};
exports.History = History;
function createHistoryAction(command) {
    return () => ({
        isEnable: command,
        run: command,
    });
}
