"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeflistE = exports.Deflist = void 0;
const core_1 = require("../../../core");
const const_1 = require("./const");
const commands_1 = require("./commands");
const fromYfm_1 = require("./fromYfm");
const toYfm_1 = require("./toYfm");
const spec_1 = require("./spec");
const mdPlugin = require('markdown-it-deflist');
const Deflist = (builder, opts) => {
    const spec = (0, spec_1.getSpec)(opts);
    builder.configureMd((md) => md.use(mdPlugin));
    builder
        .addNode(const_1.DeflistNode.List, () => ({
        spec: spec[const_1.DeflistNode.List],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.DeflistNode.List] },
        toYfm: toYfm_1.toYfm[const_1.DeflistNode.List],
    }))
        .addNode(const_1.DeflistNode.Term, () => ({
        spec: spec[const_1.DeflistNode.Term],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.DeflistNode.Term] },
        toYfm: toYfm_1.toYfm[const_1.DeflistNode.Term],
    }))
        .addNode(const_1.DeflistNode.Desc, () => ({
        spec: spec[const_1.DeflistNode.Desc],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.DeflistNode.Desc] },
        toYfm: toYfm_1.toYfm[const_1.DeflistNode.Desc],
    }));
    builder.addKeymap(() => ({ Enter: commands_1.splitDeflist }));
    builder.addAction(const_1.dlAction, () => {
        return {
            isEnable: commands_1.wrapToDeflist,
            run: commands_1.wrapToDeflist,
        };
    });
};
exports.Deflist = Deflist;
/**
 * @deprecated
 * For tests only.
 * Remove after WIKI-16660
 */
exports.DeflistE = (0, core_1.createExtension)((b, o = {}) => b.use(exports.Deflist, o));
