"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSpec = void 0;
const const_1 = require("./const");
const DEFAULT_PLACEHOLDERS = {
    Term: 'Definition term',
    Desc: 'Definition description',
};
const getSpec = (opts) => {
    var _a, _b;
    return ({
        [const_1.DeflistNode.List]: {
            group: 'block',
            content: `(${const_1.DeflistNode.Term} ${const_1.DeflistNode.Desc})+`,
            parseDOM: [{ tag: 'dl' }],
            toDOM() {
                return ['dl', 0];
            },
            selectable: true,
            allowSelection: true,
            complex: 'root',
        },
        [const_1.DeflistNode.Term]: {
            defining: true,
            group: 'block',
            content: 'inline*',
            parseDOM: [{ tag: 'dt' }],
            toDOM() {
                return ['dt', 0];
            },
            placeholder: {
                content: (_a = opts === null || opts === void 0 ? void 0 : opts.deflistTermPlaceholder) !== null && _a !== void 0 ? _a : DEFAULT_PLACEHOLDERS.Term,
                alwaysVisible: true,
            },
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
        },
        [const_1.DeflistNode.Desc]: {
            defining: true,
            group: 'block',
            content: 'block+',
            parseDOM: [{ tag: 'dd' }],
            toDOM() {
                return ['dd', 0];
            },
            placeholder: {
                content: (_b = opts === null || opts === void 0 ? void 0 : opts.deflistDescPlaceholder) !== null && _b !== void 0 ? _b : DEFAULT_PLACEHOLDERS.Desc,
                alwaysVisible: true,
            },
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
        },
    });
};
exports.getSpec = getSpec;
