"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.headingRule = exports.hasParentHeading = exports.hType = void 0;
const prosemirror_inputrules_1 = require("prosemirror-inputrules");
const prosemirror_utils_1 = require("prosemirror-utils");
const schema_1 = require("../../../utils/schema");
const const_1 = require("./const");
exports.hType = (0, schema_1.nodeTypeFactory)(const_1.heading);
const hasParentHeading = (level) => (state) => (0, prosemirror_utils_1.hasParentNode)((node) => {
    return node.type === (0, exports.hType)(state.schema) && node.attrs[const_1.lvlAttr] === level;
})(state.selection);
exports.hasParentHeading = hasParentHeading;
// Given a node type and a maximum level, creates an input rule that
// turns up to that number of `#` characters followed by a space at
// the start of a textblock into a heading whose level corresponds to
// the number of `#` signs.
function headingRule(nodeType, maxLevel) {
    return (0, prosemirror_inputrules_1.textblockTypeInputRule)(new RegExp('^(#{1,' + maxLevel + '})\\s$'), nodeType, (match) => ({ [const_1.lvlAttr]: match[1].length }));
}
exports.headingRule = headingRule;
