"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlE = exports.Html = void 0;
const core_1 = require("../../../core");
const const_1 = require("./const");
const fromYfm_1 = require("./fromYfm");
const spec_1 = require("./spec");
const toYfm_1 = require("./toYfm");
const Html = (builder) => {
    builder.addNode(const_1.HtmlNode.Block, () => ({
        spec: spec_1.spec[const_1.HtmlNode.Block],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.HtmlNode.Block] },
        toYfm: toYfm_1.toYfm[const_1.HtmlNode.Block],
    }));
    builder.addNode(const_1.HtmlNode.Inline, () => ({
        spec: spec_1.spec[const_1.HtmlNode.Inline],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.HtmlNode.Inline] },
        toYfm: toYfm_1.toYfm[const_1.HtmlNode.Inline],
    }));
};
exports.Html = Html;
/**
 * @deprecated
 * For tests only.
 * Remove after WIKI-16660
 */
exports.HtmlE = (0, core_1.createExtension)((b, o = {}) => b.use(exports.Html, o));
