"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addImage = void 0;
const const_1 = require("./const");
const utils_1 = require("./utils");
const addImage = (schema) => {
    return {
        isEnable: (state) => state.selection.empty,
        run(state, dispatch, _view, attrs) {
            const params = attrs;
            if (params === null || params === void 0 ? void 0 : params.src) {
                const { src, title, alt } = params;
                const imgAttrs = {
                    [const_1.ImageAttr.Src]: src,
                    [const_1.ImageAttr.Title]: title !== null && title !== void 0 ? title : '',
                    [const_1.ImageAttr.Alt]: alt !== null && alt !== void 0 ? alt : '',
                };
                dispatch(state.tr.insert(state.selection.from, (0, utils_1.imgType)(schema).create(imgAttrs)));
            }
        },
    };
};
exports.addImage = addImage;
