"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImageE = exports.Image = exports.imgType = void 0;
const core_1 = require("../../../core");
const actions_1 = require("./actions");
const const_1 = require("./const");
var utils_1 = require("./utils");
Object.defineProperty(exports, "imgType", { enumerable: true, get: function () { return utils_1.imgType; } });
const Image = (builder) => {
    builder.addNode(const_1.image, () => ({
        spec: {
            inline: true,
            attrs: {
                [const_1.ImageAttr.Src]: {},
                [const_1.ImageAttr.Alt]: { default: null },
                [const_1.ImageAttr.Title]: { default: null },
            },
            group: 'inline',
            draggable: true,
            parseDOM: [
                {
                    tag: 'img[src]',
                    getAttrs(dom) {
                        return {
                            [const_1.ImageAttr.Src]: dom.getAttribute(const_1.ImageAttr.Src),
                            [const_1.ImageAttr.Alt]: dom.getAttribute(const_1.ImageAttr.Alt),
                            [const_1.ImageAttr.Title]: dom.getAttribute(const_1.ImageAttr.Title),
                        };
                    },
                },
            ],
            toDOM(node) {
                return ['img', node.attrs];
            },
        },
        fromYfm: {
            tokenSpec: {
                name: const_1.image,
                type: 'node',
                getAttrs: (tok) => {
                    var _a, _b;
                    return ({
                        [const_1.ImageAttr.Src]: tok.attrGet('src'),
                        [const_1.ImageAttr.Title]: tok.attrGet('title') || null,
                        [const_1.ImageAttr.Alt]: ((_b = (_a = tok.children) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b.content) || null,
                    });
                },
            },
        },
        toYfm: (state, { attrs }) => {
            state.write('![' +
                state.esc(attrs.alt || '') +
                '](' +
                state.esc(attrs.src) +
                (attrs.title ? ' ' + state.quote(attrs.title) : '') +
                ')');
        },
    }));
    builder.addAction(const_1.addImageAction, ({ schema }) => (0, actions_1.addImage)(schema));
};
exports.Image = Image;
/**
 * @deprecated
 * For tests only.
 * Remove after WIKI-16660
 */
exports.ImageE = (0, core_1.createExtension)((b, o = {}) => b.use(exports.Image, o));
