"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toList = void 0;
const prosemirror_schema_list_1 = require("prosemirror-schema-list");
const utils_1 = require("./utils");
function toList(listType) {
    return (state, dispatch) => {
        const parentList = (0, utils_1.findAnyParentList)(state.schema)(state.selection);
        if (parentList) {
            if (listType === parentList.node.type)
                return false;
            dispatch === null || dispatch === void 0 ? void 0 : dispatch(state.tr.setNodeMarkup(parentList.pos, listType));
            return true;
        }
        return (0, prosemirror_schema_list_1.wrapInList)(listType)(state, dispatch);
    };
}
exports.toList = toList;
