"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.spec = void 0;
const const_1 = require("./const");
exports.spec = {
    [const_1.ListNode.ListItem]: {
        attrs: { tight: { default: false } },
        content: '(paragraph|block)+',
        defining: true,
        parseDOM: [{ tag: 'li' }],
        toDOM() {
            return ['li', 0];
        },
        selectable: false,
        allowSelection: false,
        disableGapCursor: true,
        complex: 'leaf',
    },
    [const_1.ListNode.BulletList]: {
        content: `${const_1.ListNode.ListItem}+`,
        group: 'block',
        parseDOM: [{ tag: 'ul' }],
        toDOM() {
            return ['ul', 0];
        },
        selectable: false,
        allowSelection: false,
        complex: 'root',
    },
    [const_1.ListNode.OrderedList]: {
        attrs: { order: { default: 1 }, tight: { default: false } },
        content: `${const_1.ListNode.ListItem}+`,
        group: 'block',
        parseDOM: [
            {
                tag: 'ol',
                getAttrs(dom) {
                    return {
                        order: dom.hasAttribute('start')
                            ? Number(dom.getAttribute('start'))
                            : 1,
                    };
                },
            },
        ],
        toDOM(node) {
            return node.attrs.order === 1 ? ['ol', 0] : ['ol', { start: node.attrs.order }, 0];
        },
        selectable: false,
        allowSelection: false,
        complex: 'root',
    },
};
