"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarkE = exports.Mark = exports.mark = void 0;
const core_1 = require("../../../core");
const schema_1 = require("../../../utils/schema");
const actions_1 = require("../../../utils/actions");
const inputrules_1 = require("../../../utils/inputrules");
const mdPlugin = require('markdown-it-mark');
exports.mark = 'mark';
const mAction = 'mark';
const mType = (0, schema_1.markTypeFactory)(exports.mark);
const Mark = (builder) => {
    builder
        .configureMd((md) => md.use(mdPlugin))
        .addMark(exports.mark, () => ({
        spec: {
            parseDOM: [{ tag: 'mark' }],
            toDOM() {
                return ['mark'];
            },
        },
        fromYfm: {
            tokenSpec: {
                name: exports.mark,
                type: 'mark',
            },
        },
        toYfm: {
            open: '==',
            close: '==',
            mixable: true,
            expelEnclosingWhitespace: true,
        },
    }))
        .addAction(mAction, ({ schema }) => (0, actions_1.createToggleMarkAction)(mType(schema)))
        .addInputRules(({ schema }) => ({
        rules: [(0, inputrules_1.markInputRule)({ open: '==', close: '==', ignoreBetween: '=' }, mType(schema))],
    }));
};
exports.Mark = Mark;
/**
 * @deprecated
 * For tests only.
 * Remove after WIKI-16660
 */
exports.MarkE = (0, core_1.createExtension)((b) => b.use(exports.Mark));
