"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableE = exports.Table = exports.TableNode = void 0;
const core_1 = require("../../../core");
const table_utils_1 = require("../../../table-utils");
const const_1 = require("./const");
const fromYfm_1 = require("./fromYfm");
const spec_1 = require("./spec");
const toYfm_1 = require("./toYfm");
const actions_1 = require("./actions");
var const_2 = require("./const");
Object.defineProperty(exports, "TableNode", { enumerable: true, get: function () { return const_2.TableNode; } });
const Table = (builder) => {
    builder
        .addNode(const_1.TableNode.Table, () => ({
        spec: spec_1.spec[const_1.TableNode.Table],
        toYfm: toYfm_1.toYfm[const_1.TableNode.Table],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.Table] },
    }))
        .addNode(const_1.TableNode.Head, () => ({
        spec: spec_1.spec[const_1.TableNode.Head],
        toYfm: toYfm_1.toYfm[const_1.TableNode.Head],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.Head] },
    }))
        .addNode(const_1.TableNode.Body, () => ({
        spec: spec_1.spec[const_1.TableNode.Body],
        toYfm: toYfm_1.toYfm[const_1.TableNode.Body],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.Body] },
    }))
        .addNode(const_1.TableNode.Row, () => ({
        spec: spec_1.spec[const_1.TableNode.Row],
        toYfm: toYfm_1.toYfm[const_1.TableNode.Row],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.Row] },
    }))
        .addNode(const_1.TableNode.HeaderCell, () => ({
        spec: spec_1.spec[const_1.TableNode.HeaderCell],
        toYfm: toYfm_1.toYfm[const_1.TableNode.HeaderCell],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.HeaderCell] },
    }))
        .addNode(const_1.TableNode.DataCell, () => ({
        spec: spec_1.spec[const_1.TableNode.DataCell],
        toYfm: toYfm_1.toYfm[const_1.TableNode.DataCell],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.DataCell] },
    }));
    builder.addKeymap(() => ({
        Tab: (0, table_utils_1.goToNextCell)('next'),
        'Shift-Tab': (0, table_utils_1.goToNextCell)('prev'),
    }));
    builder
        .addAction('createTable', actions_1.createTableAction)
        .addAction('deleteTable', () => actions_1.deleteTableAction);
};
exports.Table = Table;
/**
 * @deprecated
 * For tests only.
 * Remove after WIKI-16660
 */
exports.TableE = (0, core_1.createExtension)((b, o = {}) => b.use(exports.Table, o));
