"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarkdownBlocksPreset = exports.MarkdownMarksPreset = void 0;
const tslib_1 = require("tslib");
const lodash_1 = require("lodash");
const Bold_1 = require("./Bold");
const Code_1 = require("./Code");
const Italic_1 = require("./Italic");
const Strike_1 = require("./Strike");
const Underline_1 = require("./Underline");
const Link_1 = require("./Link");
const Mark_1 = require("./Mark");
const Subscript_1 = require("./Subscript");
const Superscript_1 = require("./Superscript");
const Html_1 = require("./Html");
const Table_1 = require("./Table");
const Image_1 = require("./Image");
const Lists_1 = require("./Lists");
const Breaks_1 = require("./Breaks");
const Deflist_1 = require("./Deflist");
const HorizontalRule_1 = require("./HorizontalRule");
const Heading_1 = require("./Heading");
const CodeBlock_1 = require("./CodeBlock");
const Blockquote_1 = require("./Blockquote");
tslib_1.__exportStar(require("./Bold"), exports);
tslib_1.__exportStar(require("./Code"), exports);
tslib_1.__exportStar(require("./Link"), exports);
tslib_1.__exportStar(require("./Italic"), exports);
tslib_1.__exportStar(require("./Strike"), exports);
tslib_1.__exportStar(require("./Underline"), exports);
tslib_1.__exportStar(require("./Mark"), exports);
tslib_1.__exportStar(require("./Subscript"), exports);
tslib_1.__exportStar(require("./Superscript"), exports);
tslib_1.__exportStar(require("./Html"), exports);
tslib_1.__exportStar(require("./Breaks"), exports);
tslib_1.__exportStar(require("./Blockquote"), exports);
tslib_1.__exportStar(require("./CodeBlock"), exports);
tslib_1.__exportStar(require("./Deflist"), exports);
tslib_1.__exportStar(require("./Lists"), exports);
tslib_1.__exportStar(require("./Image"), exports);
tslib_1.__exportStar(require("./Table"), exports);
tslib_1.__exportStar(require("./Heading"), exports);
tslib_1.__exportStar(require("./HorizontalRule"), exports);
const MarkdownMarksPreset = (builder, opts) => {
    var _a, _b, _c, _d, _e;
    builder
        .use(Bold_1.Bold, (_a = opts.bold) !== null && _a !== void 0 ? _a : {})
        .use(Code_1.Code, (_b = opts.code) !== null && _b !== void 0 ? _b : {})
        .use(Italic_1.Italic, (_c = opts.italic) !== null && _c !== void 0 ? _c : {})
        .use(Strike_1.Strike, (_d = opts.strike) !== null && _d !== void 0 ? _d : {})
        .use(Underline_1.Underline, (_e = opts.underline) !== null && _e !== void 0 ? _e : {})
        .use(Link_1.Link)
        .use(Mark_1.Mark)
        .use(Subscript_1.Subscript)
        .use(Superscript_1.Superscript);
};
exports.MarkdownMarksPreset = MarkdownMarksPreset;
const MarkdownBlocksPreset = (builder, opts) => {
    var _a, _b, _c, _d, _e, _f;
    builder
        .use(Html_1.Html)
        .use(Table_1.Table)
        .use(HorizontalRule_1.HorizontalRule)
        .use(Lists_1.Lists, (_a = opts.lists) !== null && _a !== void 0 ? _a : {})
        .use(Breaks_1.Breaks, (_b = opts.breaks) !== null && _b !== void 0 ? _b : {})
        .use(Deflist_1.Deflist, (_c = opts.deflist) !== null && _c !== void 0 ? _c : {})
        .use(CodeBlock_1.CodeBlock, (_d = opts.codeBlock) !== null && _d !== void 0 ? _d : {})
        .use(Blockquote_1.Blockquote, (_e = opts.blockquote) !== null && _e !== void 0 ? _e : {});
    if (opts.image !== false) {
        builder.use((0, lodash_1.isFunction)(opts.image) ? opts.image : Image_1.Image);
    }
    if (opts.heading !== false) {
        if ((0, lodash_1.isFunction)(opts.heading))
            builder.use(opts.heading);
        else
            builder.use(Heading_1.Heading, (_f = opts.heading) !== null && _f !== void 0 ? _f : {});
    }
};
exports.MarkdownBlocksPreset = MarkdownBlocksPreset;
