"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSpec = void 0;
const classname_1 = require("../../../classname");
const const_1 = require("./const");
const b = (0, classname_1.cn)('checkbox');
const DEFAULT_LABEL_PLACEHOLDER = 'Checkbox';
const getSpec = (opts) => {
    var _a;
    return ({
        [const_1.CheckboxNode.Checkbox]: {
            group: 'block',
            content: `${const_1.CheckboxNode.Input} ${const_1.CheckboxNode.Label}`,
            selectable: false,
            allowSelection: false,
            parseDOM: [],
            attrs: {
                class: { default: b() },
            },
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            complex: 'root',
        },
        [const_1.CheckboxNode.Input]: {
            group: 'block',
            parseDOM: [],
            attrs: {
                type: { default: 'checkbox' },
                id: { default: null },
                checked: { default: null },
            },
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
        },
        [const_1.CheckboxNode.Label]: {
            content: 'text*',
            group: 'block',
            parseDOM: [
                {
                    tag: `span[class="${b('label')}"]`,
                    getAttrs: (node) => ({
                        for: node.getAttribute('for') || '',
                    }),
                },
            ],
            attrs: {
                for: { default: null },
            },
            escapeText: false,
            placeholder: {
                content: (_a = opts === null || opts === void 0 ? void 0 : opts.checkboxLabelPlaceholder) !== null && _a !== void 0 ? _a : DEFAULT_LABEL_PLACEHOLDER,
                alwaysVisible: true,
            },
            toDOM(node) {
                return ['span', Object.assign(Object.assign({}, node.attrs), { class: b('label') }), 0];
            },
            selectable: false,
            allowSelection: false,
            disableGapCursor: true,
            complex: 'leaf',
        },
    });
};
exports.getSpec = getSpec;
