"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toYfm = void 0;
const Placeholder_1 = require("../../behavior/Placeholder");
const const_1 = require("./const");
exports.toYfm = {
    [const_1.CheckboxNode.Checkbox]: (state, node) => {
        state.renderInline(node);
        state.closeBlock(node);
    },
    [const_1.CheckboxNode.Input]: (state, node) => {
        const checked = node.attrs.checked === 'true';
        state.write(`[${checked ? 'X' : ' '}] `);
    },
    [const_1.CheckboxNode.Label]: (state, node) => {
        if (!node.content.size) {
            state.write((0, Placeholder_1.getPlaceholderContent)(node));
            return;
        }
        state.renderInline(node);
    },
};
