"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MonospaceE = exports.Monospace = exports.monospace = void 0;
const tslib_1 = require("tslib");
const monospace_1 = tslib_1.__importDefault(require("@doc-tools/transform/lib/plugins/monospace"));
const core_1 = require("../../../core");
const schema_1 = require("../../../utils/schema");
const actions_1 = require("../../../utils/actions");
const inputrules_1 = require("../../../utils/inputrules");
const log_1 = tslib_1.__importDefault(require("@doc-tools/transform/lib/log"));
exports.monospace = 'monospace';
const monoAction = 'mono';
const monoType = (0, schema_1.markTypeFactory)(exports.monospace);
const Monospace = (builder) => {
    builder
        .configureMd((md) => md.use(monospace_1.default, { log: log_1.default }))
        .addMark(exports.monospace, () => ({
        spec: {
            parseDOM: [{ tag: 'samp' }],
            toDOM() {
                return ['samp'];
            },
        },
        fromYfm: {
            tokenSpec: {
                name: exports.monospace,
                type: 'mark',
            },
        },
        toYfm: {
            open: '##',
            close: '##',
            mixable: true,
            expelEnclosingWhitespace: true,
        },
    }))
        .addAction(monoAction, ({ schema }) => (0, actions_1.createToggleMarkAction)(monoType(schema)))
        .addInputRules(({ schema }) => ({
        rules: [(0, inputrules_1.markInputRule)({ open: '##', close: '##', ignoreBetween: '#' }, monoType(schema))],
    }));
};
exports.Monospace = Monospace;
/**
 * @deprecated
 * For tests only.
 * Remove after WIKI-16660
 */
exports.MonospaceE = (0, core_1.createExtension)((b) => b.use(exports.Monospace));
