"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createViewStub = exports.serializeNodeToString = exports.vType = void 0;
const schema_1 = require("../../../utils/schema");
const const_1 = require("./const");
exports.vType = (0, schema_1.nodeTypeFactory)(const_1.video);
function serializeNodeToString(node) {
    const service = node.attrs[const_1.VideoAttr.Service];
    const videoId = node.attrs[const_1.VideoAttr.VideoID];
    return `@[${service}](${videoId})`;
}
exports.serializeNodeToString = serializeNodeToString;
function createViewStub(node) {
    const elem = document.createElement('span');
    elem.setAttribute(const_1.VideoAttr.Service, node.attrs[const_1.VideoAttr.Service]);
    elem.setAttribute(const_1.VideoAttr.VideoID, node.attrs[const_1.VideoAttr.VideoID]);
    elem.contentEditable = 'false';
    elem.textContent = serializeNodeToString(node);
    return elem;
}
exports.createViewStub = createViewStub;
