"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toYfmCut = exports.createYfmCut = void 0;
const prosemirror_utils_1 = require("prosemirror-utils");
const schema_1 = require("../../../../utils/schema");
const const_1 = require("../const");
const yfmCutType = (0, schema_1.nodeTypeFactory)(const_1.CutNode.Cut);
const yfmCutTitleType = (0, schema_1.nodeTypeFactory)(const_1.CutNode.CutTitle);
const yfmCutContentType = (0, schema_1.nodeTypeFactory)(const_1.CutNode.CutContent);
const createYfmCutNode = (schema) => (content) => {
    return yfmCutType(schema).create(null, [
        yfmCutTitleType(schema).create(null),
        yfmCutContentType(schema).create(null, content),
    ]);
};
const createYfmCut = (state, dispatch) => {
    const { schema } = state;
    const parent = (0, prosemirror_utils_1.findParentNodeOfType)(schema.nodes.paragraph)(state.selection);
    if (parent) {
        if (dispatch) {
            const yfmCut = createYfmCutNode(schema)(parent.node);
            dispatch === null || dispatch === void 0 ? void 0 : dispatch(state.tr.replaceWith(parent.pos, parent.pos + parent.node.nodeSize, yfmCut));
        }
        return true;
    }
    return false;
};
exports.createYfmCut = createYfmCut;
exports.toYfmCut = {
    isEnable(state) {
        return (0, exports.createYfmCut)(state);
    },
    run(state, dispatch) {
        (0, exports.createYfmCut)(state, dispatch);
    },
};
