"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toYfm = void 0;
const Placeholder_1 = require("../../behavior/Placeholder");
const nodes_1 = require("../../../utils/nodes");
const const_1 = require("./const");
exports.toYfm = {
    [const_1.CutNode.Cut]: (state, node) => {
        state.renderContent(node);
        state.write('{% endcut %}');
        state.closeBlock(node);
    },
    [const_1.CutNode.CutTitle]: (state, node) => {
        state.write('{% cut "');
        if (node.textContent)
            state.renderInline(node);
        else
            state.write((0, Placeholder_1.getPlaceholderContent)(node));
        state.write('" %}\n');
        state.write('\n');
        state.closeBlock();
    },
    [const_1.CutNode.CutContent]: (state, node) => {
        if (!(0, nodes_1.isNodeEmpty)(node))
            state.renderInline(node);
        else
            state.write((0, Placeholder_1.getPlaceholderContent)(node) + '\n\n');
    },
};
