"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmDist = void 0;
const lodash_1 = require("lodash");
const prosemirror_state_1 = require("prosemirror-state");
require("@doc-tools/transform/dist/js/yfm");
require("@doc-tools/transform/dist/css/yfm.css");
const YfmDist = (builder) => {
    builder.addPlugin(() => new prosemirror_state_1.Plugin({
        props: {
            attributes: {
                class: 'yfm yfm_no-list-reset',
            },
        },
    }));
    // ignore yfm lint token
    builder.addNode('__yfm_lint', () => ({
        spec: {},
        fromYfm: { tokenSpec: { name: '__yfm_lint', type: 'node', ignore: true } },
        toYfm: lodash_1.noop,
    }));
};
exports.YfmDist = YfmDist;
