"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toYfm = void 0;
const const_1 = require("./const");
exports.toYfm = {
    [const_1.TabsNode.Tab]: (state, node) => {
        state.renderInline(node);
    },
    [const_1.TabsNode.TabPanel]: (state, node) => {
        state.renderContent(node);
    },
    [const_1.TabsNode.Tabs]: (state, node) => {
        state.write('{% list tabs %}\n\n');
        const children = [];
        node.content.forEach((a) => {
            children.push(a);
        });
        const tabList = children[0].content;
        tabList.forEach((tab, _, i) => {
            state.write('- ' + tab.textContent + '\n\n');
            state.renderList(children[i + 1], '  ', () => '  ');
        });
        state.write('{% endlist %}');
    },
    [const_1.TabsNode.TabsList]: (state, node) => {
        state.renderList(node, '  ', () => (node.attrs.bullet || '-') + ' ');
    },
};
