"use strict";
var _Logger_logger;
Object.defineProperty(exports, "__esModule", { value: true });
exports.logger = void 0;
const tslib_1 = require("tslib");
const noop = () => { };
class Logger {
    constructor() {
        _Logger_logger.set(this, this.createLogger({}));
    }
    get log() {
        return tslib_1.__classPrivateFieldGet(this, _Logger_logger, "f").log;
    }
    get info() {
        return tslib_1.__classPrivateFieldGet(this, _Logger_logger, "f").info;
    }
    get error() {
        return tslib_1.__classPrivateFieldGet(this, _Logger_logger, "f").error;
    }
    get warn() {
        return tslib_1.__classPrivateFieldGet(this, _Logger_logger, "f").warn;
    }
    get metrics() {
        return tslib_1.__classPrivateFieldGet(this, _Logger_logger, "f").metrics;
    }
    setLogger(settings = {}) {
        tslib_1.__classPrivateFieldSet(this, _Logger_logger, this.createLogger(settings), "f");
    }
    /**
     * @inner
     *
     * To override the default logger, use setLogger
     */
    createLogger(settings) {
        var _a, _b, _c, _d, _e;
        return {
            log: (_a = settings.log) !== null && _a !== void 0 ? _a : noop,
            info: (_b = settings.info) !== null && _b !== void 0 ? _b : noop,
            warn: (_c = settings.warn) !== null && _c !== void 0 ? _c : noop,
            error: (_d = settings.error) !== null && _d !== void 0 ? _d : noop,
            metrics: (_e = settings.metrics) !== null && _e !== void 0 ? _e : noop,
        };
    }
}
_Logger_logger = new WeakMap();
exports.logger = new Logger();
