"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeColumn = void 0;
const prosemirror_model_1 = require("prosemirror-model");
const utils_1 = require("../utils");
const prosemirror_utils_1 = require("prosemirror-utils");
const __1 = require("..");
const removeColumn = (state, dispatch, _, attrs = {}) => {
    var _a;
    const { tablePos, columnNumber } = attrs;
    if (tablePos === undefined || columnNumber === undefined)
        return false;
    const tableNode = (_a = (0, prosemirror_utils_1.findParentNodeClosestToPos)(state.doc.resolve(tablePos + 1), __1.isTableNode)) === null || _a === void 0 ? void 0 : _a.node;
    if (!tableNode)
        return false;
    if (!tableNode.firstChild || !tableNode) {
        return false;
    }
    const allRows = (0, utils_1.findChildTableRows)(tableNode);
    if (allRows[0].node.childCount < 2) {
        // there is one column left
        return false;
    }
    if (columnNumber < 0) {
        return false;
    }
    if (dispatch) {
        let tr = state.tr;
        for (const row of allRows) {
            const rowCells = (0, utils_1.findChildTableCells)(row.node);
            const cell = rowCells[columnNumber];
            const from = tablePos + row.pos + cell.pos + 2;
            const to = from + cell.node.nodeSize;
            tr = tr.replaceWith(tr.mapping.map(from), tr.mapping.map(to), prosemirror_model_1.Fragment.empty);
        }
        dispatch(tr);
    }
    return true;
};
exports.removeColumn = removeColumn;
