"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeRow = void 0;
const prosemirror_model_1 = require("prosemirror-model");
const prosemirror_utils_1 = require("prosemirror-utils");
const core_1 = require("../../core");
const utils_1 = require("../utils");
const __1 = require("..");
const removeRow = (state, dispatch, _, attrs = {}) => {
    var _a;
    const { tablePos, rowNumber } = attrs;
    if (tablePos === undefined || rowNumber === undefined)
        return false;
    const tableNode = (_a = (0, prosemirror_utils_1.findParentNodeClosestToPos)(state.doc.resolve(tablePos + 1), __1.isTableNode)) === null || _a === void 0 ? void 0 : _a.node;
    if (!tableNode)
        return false;
    const parentRows = (0, prosemirror_utils_1.findChildren)(tableNode, __1.isTableRowNode);
    const parentBody = (0, __1.findChildTableBody)(tableNode)[0];
    const parentRow = parentRows[rowNumber];
    if (!parentRows.length || !parentBody) {
        return false;
    }
    if ((0, utils_1.findChildTableRows)(parentBody.node).length < 2) {
        // there is one row left
        return false;
    }
    dispatch === null || dispatch === void 0 ? void 0 : dispatch((0, core_1.trackTransactionMetrics)(state.tr.replaceWith(tablePos + parentRow.pos, tablePos + parentRow.pos + parentRow.node.nodeSize + 1, prosemirror_model_1.Fragment.empty), 'removeRow', { rows: parentRows.length, cols: parentRow.node.childCount }));
    return true;
};
exports.removeRow = removeRow;
