"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlexToolbar = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const react_use_1 = require("react-use");
const dots_svg_1 = tslib_1.__importDefault(require("../../../assets/icons/dots.svg"));
const classname_1 = require("../classname");
const Toolbar_1 = require("./Toolbar");
const ToolbarListButton_1 = require("./ToolbarListButton");
const flexible_1 = require("./flexible");
const logger_1 = require("../logger");
const hooks_1 = require("../react-utils/hooks");
const b = (0, classname_1.cn)('flex-toolbar');
function FlexToolbar(props) {
    (0, hooks_1.useRenderTime)((time) => {
        logger_1.logger.metrics({
            component: 'toolbar',
            event: 'render',
            duration: time,
        });
    });
    const { data, className } = props;
    const [ref, { width }] = (0, react_use_1.useMeasure)();
    const { data: items, dots } = react_1.default.useMemo(() => (0, flexible_1.shrinkToolbarData)({ data, availableWidth: width }), [data, width]);
    return (react_1.default.createElement("div", { ref: ref, className: b(null, [className]) },
        react_1.default.createElement("div", { className: b('container') },
            react_1.default.createElement(Toolbar_1.Toolbar, Object.assign({}, props, { data: items, className: b('bar') })),
            (dots === null || dots === void 0 ? void 0 : dots.length) && (react_1.default.createElement(ToolbarListButton_1.ToolbarListButton, { data: dots, icon: { data: dots_svg_1.default }, editor: props.editor, focus: props.focus, onClick: props.onClick, className: b('dots') })))));
}
exports.FlexToolbar = FlexToolbar;
