"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolbarButton = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const lodash_1 = require("lodash");
const uikit_1 = require("@yandex-cloud/uikit");
const classname_1 = require("../classname");
const b = (0, classname_1.cn)('toolbar-button');
function ToolbarButton({ className, id, title, hotkey, editor, icon, exec, focus, onClick, isActive, isEnable, }) {
    var _a;
    const active = isActive(editor);
    const enabled = isEnable(editor);
    const disabled = !active && !enabled;
    const titleText = (0, lodash_1.isFunction)(title) ? title() : title;
    return (react_1.default.createElement(uikit_1.Tooltip, { content: react_1.default.createElement(react_1.default.Fragment, null,
            titleText,
            hotkey && react_1.default.createElement("span", { className: b('hotkey') }, hotkey)) },
        react_1.default.createElement(uikit_1.Button, { size: "m", selected: active, disabled: disabled, view: active ? 'normal' : 'flat', onClick: () => {
                focus();
                exec(editor);
                onClick === null || onClick === void 0 ? void 0 : onClick(id);
            }, className: b(null, [className]), extraProps: { 'aria-label': titleText } },
            react_1.default.createElement(uikit_1.Icon, { data: icon.data, size: (_a = icon.size) !== null && _a !== void 0 ? _a : 16 }))));
}
exports.ToolbarButton = ToolbarButton;
