var _ExtensionsManager_schemaRegistry, _ExtensionsManager_parserRegistry, _ExtensionsManager_serializerRegistry, _ExtensionsManager_nodeViewCreators, _ExtensionsManager_markViewCreators, _ExtensionsManager_md, _ExtensionsManager_extensions, _ExtensionsManager_deps, _ExtensionsManager_plugins, _ExtensionsManager_actions, _ExtensionsManager_nodeViews, _ExtensionsManager_markViews;
import { __classPrivateFieldGet, __classPrivateFieldSet } from "tslib";
import { ActionsManager } from './ActionsManager';
import { ParserTokensRegistry } from './ParserTokensRegistry';
import { SchemaSpecRegistry } from './SchemaSpecRegistry';
import { SerializerTokensRegistry } from './SerializerTokensRegistry';
export class ExtensionsManager {
    constructor({ md, extensions }) {
        _ExtensionsManager_schemaRegistry.set(this, new SchemaSpecRegistry());
        _ExtensionsManager_parserRegistry.set(this, new ParserTokensRegistry());
        _ExtensionsManager_serializerRegistry.set(this, new SerializerTokensRegistry());
        _ExtensionsManager_nodeViewCreators.set(this, new Map());
        _ExtensionsManager_markViewCreators.set(this, new Map());
        _ExtensionsManager_md.set(this, void 0);
        _ExtensionsManager_extensions.set(this, void 0);
        _ExtensionsManager_deps.set(this, void 0);
        _ExtensionsManager_plugins.set(this, []);
        _ExtensionsManager_actions.set(this, {});
        _ExtensionsManager_nodeViews.set(this, {});
        _ExtensionsManager_markViews.set(this, {});
        this.processNode = (name, { spec, fromYfm, toYfm, view }) => {
            __classPrivateFieldGet(this, _ExtensionsManager_schemaRegistry, "f").addNode(name, spec);
            __classPrivateFieldGet(this, _ExtensionsManager_parserRegistry, "f").addToken(fromYfm.tokenName || name, fromYfm.tokenSpec);
            __classPrivateFieldGet(this, _ExtensionsManager_serializerRegistry, "f").addNode(name, toYfm);
            if (view) {
                __classPrivateFieldGet(this, _ExtensionsManager_nodeViewCreators, "f").set(name, view);
            }
        };
        this.processMark = (name, { spec, fromYfm, toYfm, view }) => {
            __classPrivateFieldGet(this, _ExtensionsManager_schemaRegistry, "f").addMark(name, spec);
            __classPrivateFieldGet(this, _ExtensionsManager_parserRegistry, "f").addToken(fromYfm.tokenName || name, fromYfm.tokenSpec);
            __classPrivateFieldGet(this, _ExtensionsManager_serializerRegistry, "f").addMark(name, toYfm);
            if (view) {
                __classPrivateFieldGet(this, _ExtensionsManager_markViewCreators, "f").set(name, view);
            }
        };
        __classPrivateFieldSet(this, _ExtensionsManager_md, md, "f");
        __classPrivateFieldSet(this, _ExtensionsManager_extensions, extensions, "f");
    }
    static process(md, extensions) {
        return new this({ md, extensions }).build();
    }
    build() {
        this.processExtensions();
        this.createDeps();
        this.createDerived();
        return Object.assign(Object.assign({}, __classPrivateFieldGet(this, _ExtensionsManager_deps, "f")), { actions: __classPrivateFieldGet(this, _ExtensionsManager_deps, "f").actions, rawActions: __classPrivateFieldGet(this, _ExtensionsManager_actions, "f"), plugins: __classPrivateFieldGet(this, _ExtensionsManager_plugins, "f"), nodeViews: __classPrivateFieldGet(this, _ExtensionsManager_nodeViews, "f"), markViews: __classPrivateFieldGet(this, _ExtensionsManager_markViews, "f") });
    }
    buildDeps() {
        this.processExtensions();
        this.createDeps();
        return __classPrivateFieldGet(this, _ExtensionsManager_deps, "f");
    }
    processExtensions() {
        for (const ext of __classPrivateFieldGet(this, _ExtensionsManager_extensions, "f")) {
            __classPrivateFieldSet(this, _ExtensionsManager_md, ext.configureMd(__classPrivateFieldGet(this, _ExtensionsManager_md, "f")), "f");
            ext.nodes().forEach(this.processNode);
            ext.marks().forEach(this.processMark);
        }
    }
    createDeps() {
        const schema = __classPrivateFieldGet(this, _ExtensionsManager_schemaRegistry, "f").createSchema();
        __classPrivateFieldSet(this, _ExtensionsManager_deps, {
            schema,
            actions: new ActionsManager(),
            parser: __classPrivateFieldGet(this, _ExtensionsManager_parserRegistry, "f").createParser(schema, __classPrivateFieldGet(this, _ExtensionsManager_md, "f")),
            serializer: __classPrivateFieldGet(this, _ExtensionsManager_serializerRegistry, "f").createSerializer(),
        }, "f");
    }
    createDerived() {
        const plugins = [];
        for (const ext of __classPrivateFieldGet(this, _ExtensionsManager_extensions, "f")) {
            plugins.push(...ext.plugins(__classPrivateFieldGet(this, _ExtensionsManager_deps, "f")));
            Object.assign(__classPrivateFieldGet(this, _ExtensionsManager_actions, "f"), ext.actions(__classPrivateFieldGet(this, _ExtensionsManager_deps, "f")));
        }
        // TODO: move sorting to ExtensionBuilder after WIKI-16660
        __classPrivateFieldSet(this, _ExtensionsManager_plugins, plugins.sort((a, b) => b.priority - a.priority).map((item) => item.plugin), "f");
        for (const [name, view] of __classPrivateFieldGet(this, _ExtensionsManager_nodeViewCreators, "f")) {
            __classPrivateFieldGet(this, _ExtensionsManager_nodeViews, "f")[name] = view(__classPrivateFieldGet(this, _ExtensionsManager_deps, "f"));
        }
        for (const [name, view] of __classPrivateFieldGet(this, _ExtensionsManager_markViewCreators, "f")) {
            __classPrivateFieldGet(this, _ExtensionsManager_markViews, "f")[name] = view(__classPrivateFieldGet(this, _ExtensionsManager_deps, "f"));
        }
    }
}
_ExtensionsManager_schemaRegistry = new WeakMap(), _ExtensionsManager_parserRegistry = new WeakMap(), _ExtensionsManager_serializerRegistry = new WeakMap(), _ExtensionsManager_nodeViewCreators = new WeakMap(), _ExtensionsManager_markViewCreators = new WeakMap(), _ExtensionsManager_md = new WeakMap(), _ExtensionsManager_extensions = new WeakMap(), _ExtensionsManager_deps = new WeakMap(), _ExtensionsManager_plugins = new WeakMap(), _ExtensionsManager_actions = new WeakMap(), _ExtensionsManager_nodeViews = new WeakMap(), _ExtensionsManager_markViews = new WeakMap();
