import type MarkdownIt from 'markdown-it';
import { Mark, Node, NodeType, Schema } from 'prosemirror-model';
import type { Parser, ParserToken } from '../types/parser';
declare type TokenAttrs = {
    [name: string]: unknown;
};
export declare class MarkdownParser implements Parser {
    schema: Schema;
    stack: Array<{
        type: NodeType;
        attrs?: TokenAttrs;
        content: Array<Node>;
    }>;
    marks: readonly Mark[];
    tokens: Record<string, ParserToken>;
    tokenizer: MarkdownIt;
    constructor(schema: Schema, tokenizer: MarkdownIt, tokens: Record<string, ParserToken>);
    validateLink(url: string): boolean;
    normalizeLink(url: string): string;
    normalizeLinkText(url: string): string;
    parse(text: string): Node;
    private top;
    private push;
    private getTokenAttrs;
    private getTokenSpec;
    private getTokenType;
    private handlePrimitiveToken;
    private handleMark;
    private handleNode;
    private handleBlock;
    private handleToken;
    private addNode;
    private openNode;
    private closeNode;
    private addText;
    private openMark;
    private closeMark;
    private parseTokens;
}
export {};
