import { ImageAttr } from './const';
import { imgType } from './utils';
export const addImage = (schema) => {
    return {
        isEnable: (state) => state.selection.empty,
        run(state, dispatch, _view, attrs) {
            const params = attrs;
            if (params === null || params === void 0 ? void 0 : params.src) {
                const { src, title, alt } = params;
                const imgAttrs = {
                    [ImageAttr.Src]: src,
                    [ImageAttr.Title]: title !== null && title !== void 0 ? title : '',
                    [ImageAttr.Alt]: alt !== null && alt !== void 0 ? alt : '',
                };
                dispatch(state.tr.insert(state.selection.from, imgType(schema).create(imgAttrs)));
            }
        },
    };
};
