export { chainCommands as chainOR } from 'prosemirror-commands';
/**
 * @unsafe
 *
 * Combine a number of command functions into a single function
 * (which calls them one by one until one returns false).
 * If all commands are executed successfully, the changes are applied in a single transaction.
 * If at least one command fails, no changes are applied.
 */
export const chainAND = (...commands) => {
    return (state, dispatch, view) => {
        let tr = state.tr;
        for (const cmd of commands) {
            if (!cmd(Object.assign(Object.assign(Object.assign({}, state), tr), { tr }), dispatch
                ? // eslint-disable-next-line @typescript-eslint/no-loop-func
                    (newTr) => {
                        tr = newTr;
                    }
                : undefined, view)) {
                return false;
            }
        }
        dispatch === null || dispatch === void 0 ? void 0 : dispatch(tr);
        return true;
    };
};
