import { CutNode } from './const';
const DEFAULT_PLACEHOLDERS = {
    Title: 'Cut title',
    Content: 'Cut content',
};
export const getSpec = (opts) => {
    var _a, _b;
    return ({
        [CutNode.Cut]: {
            attrs: { class: { default: 'yfm-cut' } },
            content: `${CutNode.CutTitle} ${CutNode.CutContent}`,
            group: 'block',
            parseDOM: [{ tag: 'div.yfm-cut' }],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            allowGapCursor: true,
            selectable: true,
            allowSelection: true,
            defining: true,
            complex: 'root',
        },
        [CutNode.CutTitle]: {
            attrs: { class: { default: 'yfm-cut-title' } },
            content: 'text*',
            group: 'block',
            parseDOM: [{ tag: 'div.yfm-cut-title' }],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            placeholder: {
                content: (_a = opts === null || opts === void 0 ? void 0 : opts.yfmCutTitlePlaceholder) !== null && _a !== void 0 ? _a : DEFAULT_PLACEHOLDERS.Title,
                alwaysVisible: true,
            },
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
        },
        [CutNode.CutContent]: {
            attrs: { class: { default: 'yfm-cut-content' } },
            content: '(block | paragraph)+',
            group: 'block',
            parseDOM: [{ tag: 'div.yfm-cut-content' }],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            placeholder: {
                content: (_b = opts === null || opts === void 0 ? void 0 : opts.yfmCutContentPlaceholder) !== null && _b !== void 0 ? _b : DEFAULT_PLACEHOLDERS.Content,
                alwaysVisible: true,
            },
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
        },
    });
};
