import { setBlockType } from 'prosemirror-commands';
import { findParentNodeOfType } from 'prosemirror-utils';
import { YfmHeadingAttr } from './const';
import { hType } from './utils';
export { resetHeading } from '../../markdown/Heading/commands';
export const toHeading = (level) => (state, dispatch) => {
    const parentHeading = findParentNodeOfType(hType(state.schema))(state.selection);
    if (parentHeading) {
        dispatch === null || dispatch === void 0 ? void 0 : dispatch(state.tr.setNodeMarkup(parentHeading.pos, undefined, Object.assign(Object.assign({}, parentHeading.node.attrs), { [YfmHeadingAttr.Level]: level })));
        return true;
    }
    // const text = state.selection.$head.parent.textContent;
    const attrs = {
        // [YfmHeadingAttr.Id]: slugify(text),
        [YfmHeadingAttr.Level]: level,
    };
    return setBlockType(hType(state.schema), attrs)(state, dispatch);
};
