import type { NodeSpec } from 'prosemirror-model';
import { Action, ExtensionAuto } from '../../../core';
import { HeadingAction } from './const';
export { YfmHeadingAttr } from './const';
export declare type YfmHeadingOptions = {
    h1Key?: string | null;
    h2Key?: string | null;
    h3Key?: string | null;
    h4Key?: string | null;
    h5Key?: string | null;
    h6Key?: string | null;
    headingPlaceholder?: NonNullable<NodeSpec['placeholder']>['content'];
};
/** YfmHeading extension needs markdown-it-attrs plugin */
export declare const YfmHeading: ExtensionAuto<YfmHeadingOptions>;
/**
 * @deprecated
 * For tests only.
 * Remove after WIKI-16660
 */
export declare const YfmHeadingE: (opts?: YfmHeadingOptions | undefined) => import("../../../core").ExtensionSpec;
declare global {
    namespace YfmEditor {
        interface Actions {
            [HeadingAction.ToH1]: Action;
            [HeadingAction.ToH2]: Action;
            [HeadingAction.ToH3]: Action;
            [HeadingAction.ToH4]: Action;
            [HeadingAction.ToH5]: Action;
            [HeadingAction.ToH6]: Action;
        }
    }
}
