import { NoteAttrs, NoteNode } from './const';
const DEFAULT_TITLE_PLACEHOLDER = 'Note title';
export const getSpec = (opts) => {
    var _a;
    return ({
        [NoteNode.Note]: {
            attrs: {
                [NoteAttrs.Class]: { default: 'yfm-note yfm-accent-info' },
                [NoteAttrs.Type]: { default: 'info' },
            },
            content: `${NoteNode.NoteTitle} block+`,
            group: 'block',
            parseDOM: [
                {
                    tag: 'div.yfm-note',
                    getAttrs: (node) => ({
                        [NoteAttrs.Class]: node.getAttribute(NoteAttrs.Class) || '',
                        [NoteAttrs.Type]: node.getAttribute(NoteAttrs.Type) || '',
                    }),
                },
            ],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            selectable: true,
            allowSelection: true,
            allowGapCursor: true,
            complex: 'root',
        },
        [NoteNode.NoteTitle]: {
            content: 'text*',
            group: 'block',
            parseDOM: [
                {
                    tag: 'p[yfm_block="yfm-note-title"]',
                    priority: 100,
                },
            ],
            toDOM() {
                return ['p', { yfm_block: 'yfm-note-title' }, 0];
            },
            selectable: false,
            allowSelection: false,
            placeholder: {
                content: (_a = opts === null || opts === void 0 ? void 0 : opts.yfmNoteTitlePlaceholder) !== null && _a !== void 0 ? _a : DEFAULT_TITLE_PLACEHOLDER,
                alwaysVisible: true,
            },
            complex: 'leaf',
        },
    });
};
