import { TableRole } from '../../../table-utils';
import { YfmTableNode } from './const';
const DEFAULT_CELL_PLACEHOLDER = 'Table cell';
export const getSpec = (opts) => {
    var _a;
    return ({
        [YfmTableNode.Table]: {
            group: 'block',
            content: `${YfmTableNode.Body}`,
            isolating: true,
            parseDOM: [{ tag: 'table' }],
            toDOM() {
                return ['table', 0];
            },
            selectable: true,
            allowSelection: true,
            allowGapCursor: true,
            tableRole: TableRole.Table,
            complex: 'root',
        },
        [YfmTableNode.Body]: {
            group: 'block',
            content: `${YfmTableNode.Row}+`,
            isolating: true,
            parseDOM: [{ tag: 'tbody' }],
            toDOM() {
                return ['tbody', 0];
            },
            tableRole: TableRole.Body,
            selectable: false,
            allowSelection: false,
            complex: 'inner',
        },
        [YfmTableNode.Row]: {
            group: 'block',
            content: `${YfmTableNode.Cell}+`,
            isolating: true,
            parseDOM: [{ tag: 'tr' }],
            toDOM() {
                return ['tr', 0];
            },
            allowGapCursor: false,
            tableRole: TableRole.Row,
            selectable: false,
            allowSelection: false,
            complex: 'inner',
        },
        [YfmTableNode.Cell]: {
            group: 'block',
            content: 'block+',
            isolating: true,
            parseDOM: [{ tag: 'td' }],
            toDOM() {
                return ['td', 0];
            },
            placeholder: {
                content: (_a = opts === null || opts === void 0 ? void 0 : opts.yfmTableCellPlaceholder) !== null && _a !== void 0 ? _a : DEFAULT_CELL_PLACEHOLDER,
                alwaysVisible: true,
            },
            tableRole: TableRole.Cell,
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
        },
    });
};
