import { Fragment } from 'prosemirror-model';
import { findParentTable, findParentTableBody, findParentTableRow, findParentTableCell, } from '../utils';
export const transpose = (state, dispatch) => {
    var _a, _b;
    const parentCell = findParentTableCell(state.selection);
    const parentRow = findParentTableRow(state.selection);
    const parentBody = findParentTableBody(state.selection);
    const parentTable = findParentTable(state.selection);
    if (!parentCell || !parentRow || !parentBody || !parentTable)
        return false;
    if (dispatch) {
        const rowsCount = parentBody.node.childCount;
        const cellsCount = (_b = (_a = parentBody.node.maybeChild(0)) === null || _a === void 0 ? void 0 : _a.childCount) !== null && _b !== void 0 ? _b : 0;
        const newRowsList = [];
        for (let i = 0; i < cellsCount; i++) {
            const newCellsList = [];
            for (let j = 0; j < rowsCount; j++) {
                const cellNode = parentBody.node.child(j).child(i);
                newCellsList.push(cellNode.copy(cellNode.content));
            }
            newRowsList.push(parentRow.node.copy(Fragment.from(newCellsList)));
        }
        const newBody = parentBody.node.copy(Fragment.from(newRowsList));
        const newTable = parentTable.node.copy(Fragment.from(newBody));
        dispatch(state.tr.replaceWith(parentTable.pos, parentTable.pos + parentTable.node.nodeSize, newTable));
    }
    return true;
};
