import React from 'react';
import { useMeasure } from 'react-use';
import dotsIcon from '../../../assets/icons/dots.svg';
import { cn } from '../classname';
import { Toolbar } from './Toolbar';
import { ToolbarListButton } from './ToolbarListButton';
import { shrinkToolbarData } from './flexible';
import { logger } from '../logger';
import { useRenderTime } from '../react-utils/hooks';
import './FlexToolbar.css';
const b = cn('flex-toolbar');
export function FlexToolbar(props) {
    useRenderTime((time) => {
        logger.metrics({
            component: 'toolbar',
            event: 'render',
            duration: time,
        });
    });
    const { data, className } = props;
    const [ref, { width }] = useMeasure();
    const { data: items, dots } = React.useMemo(() => shrinkToolbarData({ data, availableWidth: width }), [data, width]);
    return (React.createElement("div", { ref: ref, className: b(null, [className]) },
        React.createElement("div", { className: b('container') },
            React.createElement(Toolbar, Object.assign({}, props, { data: items, className: b('bar') })),
            (dots === null || dots === void 0 ? void 0 : dots.length) && (React.createElement(ToolbarListButton, { data: dots, icon: { data: dotsIcon }, editor: props.editor, focus: props.focus, onClick: props.onClick, className: b('dots') })))));
}
