import React from 'react';
import { isFunction } from 'lodash';
import { Button, Icon, Tooltip } from '@yandex-cloud/uikit';
import { cn } from '../classname';
import './ToolbarButton.css';
const b = cn('toolbar-button');
export function ToolbarButton({ className, id, title, hotkey, editor, icon, exec, focus, onClick, isActive, isEnable, }) {
    var _a;
    const active = isActive(editor);
    const enabled = isEnable(editor);
    const disabled = !active && !enabled;
    const titleText = isFunction(title) ? title() : title;
    return (React.createElement(Tooltip, { content: React.createElement(React.Fragment, null,
            titleText,
            hotkey && React.createElement("span", { className: b('hotkey') }, hotkey)) },
        React.createElement(Button, { size: "m", selected: active, disabled: disabled, view: active ? 'normal' : 'flat', onClick: () => {
                focus();
                exec(editor);
                onClick === null || onClick === void 0 ? void 0 : onClick(id);
            }, className: b(null, [className]), extraProps: { 'aria-label': titleText } },
            React.createElement(Icon, { data: icon.data, size: (_a = icon.size) !== null && _a !== void 0 ? _a : 16 }))));
}
